/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2006 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */
package org.ow2.petals.bpel.engine.env;

import org.objectweb.fractal.fraclet.extensions.Membrane;
import org.ow2.petals.bpel.engine.message.JBIContextImpl;
import org.ow2.petals.bpel.engine.message.JBIExternalMessageImpl;

import com.ebmwebsourcing.easybpel.model.bpel.impl.message.BPELInternalMessageImpl;
import com.ebmwebsourcing.easyviper.core.api.CoreException;
import com.ebmwebsourcing.easyviper.core.api.env.ExternalContext;
import com.ebmwebsourcing.easyviper.core.api.env.Receiver;
import com.ebmwebsourcing.easyviper.core.api.soa.message.ExternalMessage;
import com.ebmwebsourcing.easyviper.core.api.soa.message.InternalMessage;
import com.ebmwebsourcing.easyviper.core.impl.env.AbstractReceiverImpl;

/**
 * @author Nicolas Salatge - eBM WebSourcing
 */
@org.objectweb.fractal.fraclet.annotations.Component
@Membrane(controller="primitive")
public class JBIReceiverImpl extends AbstractReceiverImpl implements Receiver {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	
	
	@SuppressWarnings("unchecked")
	public void accept(final ExternalMessage externalMessage, final ExternalContext context) throws CoreException {
		
		if(this.messageConverter == null) {
			throw new CoreException("Configuration error: The message converter and the type of internal message must be setted");
		}
		
		JBIContextImpl jbiContext = (JBIContextImpl) context;
		JBIExternalMessageImpl jbiMsg = (JBIExternalMessageImpl) externalMessage;

		//System.out.println("External message : \n" + XMLPrettyPrinter.prettyPrint(jbiMsg.getContent().getOwnerDocument()));
		// convert message
		final InternalMessage<?> internalMessage = this.messageConverter.createInternalMessageFromExternalMessage(externalMessage);

		BPELInternalMessageImpl bpelMsg = (BPELInternalMessageImpl) internalMessage;

		
		// give the message to Core
		jbiContext.getListener().getLogger().info("the receiver gives the message to workflow engine");
		this.getExternalEnvironment().getEngine().accept(internalMessage, context);
		
	}




}
