/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2006 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */
package org.ow2.petals.bpel.engine.message;

import org.ow2.petals.bpel.engine.handler.JBITerminationHandler;
import org.ow2.petals.bpel.engine.listener.JBIListener;
import org.ow2.petals.bpel.engine.util.Sender;
import org.ow2.petals.component.framework.api.message.Exchange;

import com.ebmwebsourcing.easyviper.core.api.engine.handler.TerminationHandler;
import com.ebmwebsourcing.easyviper.core.api.env.ExternalContext;

/**
 * @author Nicolas Salatge - eBM WebSourcing
 */
public class JBIContextImpl implements ExternalContext {

	private final Exchange initialExchange;
	
	private final Sender sender;
	
	private final JBIListener listener;
	
	private TerminationHandler th = new JBITerminationHandler();
	
	public JBIContextImpl(final Exchange exchange, final Sender sender, final JBIListener listener) {
		this.initialExchange = exchange;
		this.sender = sender;
		this.listener = listener;
	}
	
	public Exchange getInitialExchange() {
		return this.initialExchange;
	}

	public Sender getSender() {
		return this.sender;
	}
	
	public JBIListener getListener() {
	    return this.listener;
	}


    public TerminationHandler getTerminationHandler() {
        return this.th;
    }

    public void setTerminationHandler(TerminationHandler th) {
        this.th = th;
    }
}
