/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2006 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */
package org.ow2.petals.bpel.engine.util;

import java.io.File;
import java.net.MalformedURLException;
import java.net.URL;

/**
 * @author Nicolas Salatge - eBM WebSourcing
 */
public class Util {

	/**
	 * We retrieve the URL associated to the resource
	 *
	 * @param resourceName
	 *            the resource name
	 * @return the URL
	 * @throws MalformedURLException
	 *             impossible to generate url
	 */
	public static URL getResourceAsURL(final String rootPath, final String resourceName)
	throws MalformedURLException {
	    try {
	        return new URL(resourceName);
	    } catch(final MalformedURLException e) {
	        return new File(rootPath + "/" + resourceName).toURI().toURL();
	    }
	}
}
